import { ChangeDetectorRef, Component, EventEmitter, Input, Output } from '@angular/core';
import { ToastrService } from 'ngx-toastr';
import { EmployeeModel, MyEmployeeModel } from 'src/app/shared/model/employee.model';
import { EmployeeService } from 'src/app/shared/services/employee.service';
export interface DataEmployee {
  loading: boolean
  select: EmployeeModel
  dataList: {
    check: boolean
    data: EmployeeModel
  }[]
}
@Component({
  selector: 'app-sub-employee-registration',
  templateUrl: './sub-employee-registration.component.html',
  styleUrls: ['./sub-employee-registration.component.scss']
})

export class SubEmployeeRegistrationComponent {
  employee: DataEmployee = { loading: false, select: new MyEmployeeModel({}), dataList: [] }
  constructor(private toastr: ToastrService,
    private employeeService: EmployeeService,
    private cdr: ChangeDetectorRef) { }

  ngOnInit(): void {

  }
  getPageList() {
    this.employee.loading = false
    this.employeeService.getPageList().subscribe({
      next: response => {
        this.employee.dataList = response.map(x => ({ check: false, data: new MyEmployeeModel(x) }))
        this.employee.loading = false
        this.cdr.detectChanges()
      }, error: error => {
        this.employee.loading = false
        this.cdr.detectChanges()
      }
    })
  }
  // searchChange() {
  //   this.currentPage = 1
  //   this.page = Array.from({ length: Math.ceil(this.emp_typeListFilter().length / 10) }, (_, i) => i + 1);
  // }
  // emp_typeListFilter() {
  //   return this.emp_typeList.filter(x =>
  //     x.codeId.includes(this.search) ||
  //     x.tdesc.includes(this.search) ||
  //     x.edesc.includes(this.search))
  // }
  // selectEmp_type(emp_type?: EmpTypeModel) {
  //   // this.showSuccess()
  //   this.emp_type = new MyEmpTypeModel(emp_type || {})
  // }
  showSuccess() {
    this.toastr.success('บันทึกข้อมูลสำเร็จ', 'เเจ้งเตือน', {
      timeOut: 3000,
      positionClass: 'toast-top-right',
    });
  }
  showSuccessDelete() {
    this.toastr.success('ลบข้อมูลสำเร็จ', 'เเจ้งเตือน', {
      timeOut: 3000,
      positionClass: 'toast-top-right',
    });
  }
  addUser() {

  }
}
