import { AgeModel, MyAgeModel } from "./age.model"
import { JobCodeModel, MyJobCodeModel } from "./job-code.model"
import { MyNationalModel, NationalModel } from "./national.model"
import { MyNationalityModel, NationalityModel } from "./nationality.model"
import { MyPLModel, PLModel } from "./pl.model"
import { MyPositionModel, PositionModel } from "./position.model"
import { MyPrefixModel, PrefixModel } from "./prefix.model"
import { MyReligionModel, ReligionModel } from "./religion.model"
import { MyStatusModel, StatusModel } from "./status.model"

export interface EmployeeModel {
    employeeId: string
    prefix: PrefixModel
    fname: string
    lname: string
    efname: string
    elname: string
    nickname: string
    enickname: string
    birthDate: string
    status: StatusModel
    age: AgeModel
    swipeCardId: string
    idPeople: string
    idexpdate: string
    passport_no: string
    passport_expire_date: string
    height: string
    weight: string
    blood: string
    rh: string
    eyeColor: string
    hairColor: string
    shirtSize: string
    waistSize: string
    national: NationalModel
    nationality: NationalityModel
    religion: ReligionModel
    sex: string
    email: string
    emailMicrosoft365: string
    emailPersonal: string
    picture: string
    telNo: string
    mobile: string
    position: PositionModel
    jobCode: JobCodeModel
    personalLevel: PLModel
}

export class MyEmployeeModel implements EmployeeModel {
    employeeId: string
    prefix: PrefixModel
    fname: string
    lname: string
    efname: string
    elname: string
    nickname: string
    enickname: string
    birthDate: string
    status: StatusModel
    age: AgeModel
    swipeCardId: string
    idPeople: string
    idexpdate: string
    passport_no: string
    passport_expire_date: string
    height: string
    weight: string
    blood: string
    rh: string
    eyeColor: string
    hairColor: string
    shirtSize: string
    waistSize: string
    national: NationalModel
    nationality: NationalityModel
    religion: ReligionModel
    sex: string
    email: string
    emailMicrosoft365: string
    emailPersonal: string
    picture: string
    telNo: string
    mobile: string
    position: PositionModel
    jobCode: JobCodeModel
    personalLevel: PLModel
    constructor(data: Partial<EmployeeModel>) {
        this.employeeId = data.employeeId || ""
        this.prefix = new MyPrefixModel(data.prefix || {})
        this.fname = data.fname || ""
        this.lname = data.lname || ""
        this.efname = data.efname || ""
        this.elname = data.elname || ""
        this.nickname = data.nickname || ""
        this.enickname = data.enickname || ""
        this.birthDate = data.birthDate || ""
        this.status = new MyStatusModel(data.status || {})
        this.age = new MyAgeModel(data.age || {})
        this.swipeCardId = data.swipeCardId || ""
        this.idPeople = data.idPeople || ""
        this.idexpdate = data.idexpdate || ""
        this.passport_no = data.passport_no || ""
        this.passport_expire_date = data.passport_expire_date || ""
        this.height = data.height || ""
        this.weight = data.weight || ""
        this.blood = data.blood || ""
        this.rh = data.rh || ""
        this.eyeColor = data.eyeColor || ""
        this.hairColor = data.hairColor || ""
        this.shirtSize = data.shirtSize || ""
        this.waistSize = data.waistSize || ""
        this.national = new MyNationalModel(data.national || {})
        this.nationality = new MyNationalityModel(data.nationality || {})
        this.religion = new MyReligionModel(data.religion || {})
        this.sex = data.sex || ""
        this.email = data.email || ""
        this.emailMicrosoft365 = data.emailMicrosoft365 || ""
        this.emailPersonal = data.emailPersonal || ""
        this.picture = data.picture || ""
        this.telNo = data.telNo || ""
        this.mobile = data.mobile || ""
        this.position = new MyPositionModel(data.position || {})
        this.jobCode = new MyJobCodeModel(data.jobCode || {})
        this.personalLevel = new MyPLModel(data.personalLevel || {})
    }
}

