import { HttpClient, HttpHeaders } from '@angular/common/http';
import { Injectable } from '@angular/core';
import { Observable } from 'rxjs';
import { environment } from 'src/environments/environment';
import { EmployeeModel } from '../model/employee.model';
@Injectable({
  providedIn: 'root'
})
export class EmployeeService {
  api = "/employee"
  urlApi = environment.baseUrl + this.api
  constructor(private http: HttpClient) {
  }
  getPageList(): Observable<EmployeeModel[]> {
    return this.http.get<EmployeeModel[]>(this.urlApi + "/profiles")
  }
  getById(employeeId: string): Observable<EmployeeModel> {
    return this.http.get<EmployeeModel>(this.urlApi + "/profile?employeeId=" + employeeId)
  }
  add(body: EmployeeModel) {
    return this.http.post(this.urlApi + '/profile-create', body)
  }
  update(body: EmployeeModel) {
    return this.http.post(this.urlApi + '/profile-update', body)
  }
  delete(body: EmployeeModel) {
    const options = {
      headers: new HttpHeaders({
        "Content-Type": "application/json",
      }),
      body: body
    };
    return this.http.delete(this.urlApi, options)
  }
}
